/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __draw_DrawNull_h__
#define __draw_DrawNull_h__

namespace fe
{

/**************************************************************************//**
	@brief Draw nothing for DrawI, elegantly

	@ingroup draw
*//***************************************************************************/
class FE_DL_EXPORT DrawNull: virtual public DrawI
{
	public:
virtual	BWORD			isDirect(void) const	{ return TRUE; }

virtual	void			setDrawMode(sp<DrawMode> spDrawMode)				{}
virtual	sp<DrawMode>	drawMode(void) const	{ return sp<DrawMode>(NULL); }
virtual void			pushDrawMode(sp<DrawMode> mode)						{}
virtual sp<DrawMode>	popDrawMode(void)		{ return sp<DrawMode>(NULL); }
virtual void			setView(sp<ViewI> spViewI)							{}
virtual sp<ViewI>		view(void) const		{ return sp<ViewI>(NULL); }

virtual	void			flush(void)											{}
virtual	void			flushLive(void)										{}
virtual	void			clearInput(void)									{}

virtual	void			setFontBase(U32 index)								{}
virtual void			drawPoints(const SpatialVector *vertex,
								const SpatialVector *normal,U32 vertices,
								BWORD multicolor,const Color *color)		{}
virtual	void			drawLines(const SpatialVector *vertex,
								const SpatialVector *normal,U32 vertices,
								StripMode strip,BWORD multicolor,
								const Color *color)							{}
virtual void			drawTriangles(const SpatialVector *vertex,
								const SpatialVector *normal,
								const Vector2f *texture,U32 vertices,
								StripMode strip,BWORD multicolor,
								const Color *color)							{}
virtual void			drawRectangles(const SpatialVector *vertex,
								U32 vertices,
								BWORD multicolor,const Color *color)		{}
virtual void			draw(cp<DrawableI> cpDrawableI,const Color* color)	{}
virtual void			drawTransformed(const SpatialTransform& transform,
								cp<DrawableI> cpDrawableI,
								const Color* color)							{}
virtual void			drawBox(const Box3& box,const Color& color)			{}
virtual	void			drawAlignedText(const SpatialVector& location,
								const char *text,const Color& color)		{}
virtual void			drawCircle(const SpatialTransform& transform,
								const SpatialVector *scale,
								const Color& color)							{}
virtual void			drawSphere(const SpatialTransform& transform,
								const SpatialVector *scale,
								const Color& color)							{}
virtual void			drawCylinder(const SpatialTransform& transform,
								const SpatialVector *scale,Real baseScale,
								const Color& color,U32 slices)				{}
virtual void			drawCylinder(const SpatialVector& location1,
								const SpatialVector& location2,
								Real radius1,Real radius2,
								const Color& color,U32 slices)				{}
virtual void			drawCylinders(const SpatialTransform* transform,
								const SpatialVector* scale,
								const Real *baseScale,
								const U32* slices,U32 cylinders,
								BWORD multicolor,const Color* color)		{}
virtual	void			drawArc(const SpatialTransform& transform,
								const SpatialVector *scale,
								Real startangle,Real endangle,
								const Color& color)							{}
virtual void			drawTransformedPoints(
								const SpatialTransform& transform,
								const SpatialVector *scale,
								const SpatialVector *vertex,
								const SpatialVector *normal,U32 vertices,
								BWORD multicolor,const Color *color)		{}
virtual void			drawTransformedTriangles(
								const SpatialTransform& transform,
								const SpatialVector *scale,
								const SpatialVector *vertex,
								const SpatialVector *normal,
								const Vector2f *texture,
								U32 vertices,StripMode strip,BWORD multicolor,
								const Color *color)							{}
virtual void			drawTransformedLines(
								const SpatialTransform& transform,
								const SpatialVector *scale,
								const SpatialVector *vertex,
								const SpatialVector *normal,
								U32 vertices,StripMode strip,
								BWORD multicolor,const Color *color)		{}
virtual void			drawAxes(Real scale)								{}
virtual void			drawTransformedAxes(const SpatialTransform& transform,
								Real scale)									{}
virtual void			drawMarker(Real radius,const Color& color)			{}
virtual void			drawTransformedMarker(
								const SpatialTransform& transform,
								Real radius,const Color& color)				{}
virtual	void			drawRaster(sp<ImageI> spImageI,
								SpatialVector& location)					{}
};

} // namespace

#endif /* __draw_DrawNull_h__ */
